package Vehicles;

import java.util.Stack;

public class AutomobileAutomata {

    public Automobile a;
    public AutomobileAutomataStates myState;

    public AutomobileAutomata() {
        this.transiteToStable(AutomobileAutomataStates.ROOT);
    }

    public AutomobileAutomataStates getState() {
        return this.myState;
    }

    public void setState(AutomobileAutomataStates state) {
        this.myState = state;
    }

    public void enterState(AutomobileAutomataStates state) {
        if (state == AutomobileAutomataStates.s0) {
        }
        if (state == AutomobileAutomataStates.s1) {
        }
        if (state == AutomobileAutomataStates.s2) {
        }
        if (state == AutomobileAutomataStates.s3) {
        }
        if (state == AutomobileAutomataStates.s4) {
        }
        if (state == AutomobileAutomataStates.s5) {
        }
        if (state == AutomobileAutomataStates.s6) {
        }
        if (state == AutomobileAutomataStates.s7) {
        }
    }

    public void enterStateRange(AutomobileAutomataStates fromSuperstateExclusive, AutomobileAutomataStates toSubstateInclusive) {
        Stack<AutomobileAutomataStates> stack = new Stack<AutomobileAutomataStates>();
        for (AutomobileAutomataStates curState = toSubstateInclusive; curState != fromSuperstateExclusive; curState = curState.superstate)
        {
            stack.push(curState);
        }
        while (!(stack.isEmpty())) {
            AutomobileAutomataStates curState = stack.pop();
            this.enterState(curState);
        }
    }

    public AutomobileAutomataStates transiteToStable(AutomobileAutomataStates state) {
        while (state.initialSubstate != null) {
            this.transiteFromInitial(state.initialSubstate);
            state = state.initialSubstate.getPointedState();
            this.enterState(state);
        }
        return state;
    }

    public void transiteFromInitial(AutomobileAutomataStates state) {
        if (state == AutomobileAutomataStates.si) {
        }
    }

    public void exitState(AutomobileAutomataStates state) {
        if (state == AutomobileAutomataStates.s0) {
        }
        if (state == AutomobileAutomataStates.s1) {
        }
        if (state == AutomobileAutomataStates.s2) {
        }
        if (state == AutomobileAutomataStates.s3) {
        }
        if (state == AutomobileAutomataStates.s4) {
        }
        if (state == AutomobileAutomataStates.s5) {
        }
        if (state == AutomobileAutomataStates.s6) {
        }
        if (state == AutomobileAutomataStates.s7) {
        }
    }

    public void exitStateRange(AutomobileAutomataStates fromSubstateInclusive, AutomobileAutomataStates toSuperstateExclusive) {
        for (AutomobileAutomataStates curState = fromSubstateInclusive; curState != toSuperstateExclusive; curState = curState.superstate)
        {
            this.exitState(curState);
        }
    }

    public void e0() {
        for (AutomobileAutomataStates sourceState = this.getState(); sourceState != AutomobileAutomataStates.ROOT; sourceState = sourceState.superstate)
        {
            if (((sourceState == AutomobileAutomataStates.s0) && (this.a.x0())) && (true)) {
                this.exitStateRange(AutomobileAutomataStates.s0, AutomobileAutomataStates.ROOT);
                this.enterStateRange(AutomobileAutomataStates.ROOT, AutomobileAutomataStates.s1);
                this.setState(this.transiteToStable(AutomobileAutomataStates.s1));
                break;
            }
            if (((sourceState == AutomobileAutomataStates.s0) && (this.a.x1())) && (true)) {
                this.exitStateRange(AutomobileAutomataStates.s0, AutomobileAutomataStates.ROOT);
                this.a.z3();
                this.a.z4();
                this.enterStateRange(AutomobileAutomataStates.ROOT, AutomobileAutomataStates.s2);
                this.setState(this.transiteToStable(AutomobileAutomataStates.s2));
                break;
            }
            if (((sourceState == AutomobileAutomataStates.s1) && (!(this.a.x0()))) && (true)) {
                this.exitStateRange(AutomobileAutomataStates.s1, AutomobileAutomataStates.ROOT);
                this.enterStateRange(AutomobileAutomataStates.ROOT, AutomobileAutomataStates.s0);
                this.setState(this.transiteToStable(AutomobileAutomataStates.s0));
                break;
            }
            if (((sourceState == AutomobileAutomataStates.s2) && (this.a.x0())) && (true)) {
                this.exitStateRange(AutomobileAutomataStates.s2, AutomobileAutomataStates.ROOT);
                this.a.z0();
                this.enterStateRange(AutomobileAutomataStates.ROOT, AutomobileAutomataStates.s3);
                this.setState(this.transiteToStable(AutomobileAutomataStates.s3));
                break;
            }
            if (((sourceState == AutomobileAutomataStates.s2) && (this.a.x2() && (!(this.a.x4()) || !(this.a.x5())))) && (true)) {
                this.exitStateRange(AutomobileAutomataStates.s2, AutomobileAutomataStates.ROOT);
                this.a.z0();
                this.enterStateRange(AutomobileAutomataStates.ROOT, AutomobileAutomataStates.s4);
                this.setState(this.transiteToStable(AutomobileAutomataStates.s4));
                break;
            }
            if (((sourceState == AutomobileAutomataStates.s2) && (this.a.x2() && this.a.x4() && this.a.x5() && (this.a.x3() == 2))) && (true)) {
                this.exitStateRange(AutomobileAutomataStates.s2, AutomobileAutomataStates.ROOT);
                this.a.z5();
                this.enterStateRange(AutomobileAutomataStates.ROOT, AutomobileAutomataStates.s5);
                this.setState(this.transiteToStable(AutomobileAutomataStates.s5));
                break;
            }
            if (((sourceState == AutomobileAutomataStates.s2) && (this.a.x2() && this.a.x4() && this.a.x5() && (this.a.x3() == 1))) && (true)) {
                this.exitStateRange(AutomobileAutomataStates.s2, AutomobileAutomataStates.ROOT);
                this.a.z5();
                this.enterStateRange(AutomobileAutomataStates.ROOT, AutomobileAutomataStates.s6);
                this.setState(this.transiteToStable(AutomobileAutomataStates.s6));
                break;
            }
            if (((sourceState == AutomobileAutomataStates.s2) && (this.a.x2() && this.a.x4() && this.a.x5() && (this.a.x3() == 0))) && (true)) {
                this.exitStateRange(AutomobileAutomataStates.s2, AutomobileAutomataStates.ROOT);
                this.a.z5();
                this.enterStateRange(AutomobileAutomataStates.ROOT, AutomobileAutomataStates.s7);
                this.setState(this.transiteToStable(AutomobileAutomataStates.s7));
                break;
            }
            if (((sourceState == AutomobileAutomataStates.s3) && (!(this.a.x0()))) && (true)) {
                this.exitStateRange(AutomobileAutomataStates.s3, AutomobileAutomataStates.ROOT);
                this.a.z0();
                this.enterStateRange(AutomobileAutomataStates.ROOT, AutomobileAutomataStates.s2);
                this.setState(this.transiteToStable(AutomobileAutomataStates.s2));
                break;
            }
            if (((sourceState == AutomobileAutomataStates.s4) && (this.a.x4() && this.a.x5() && (this.a.x3() == 2))) && (true)) {
                this.exitStateRange(AutomobileAutomataStates.s4, AutomobileAutomataStates.ROOT);
                this.a.z5();
                this.enterStateRange(AutomobileAutomataStates.ROOT, AutomobileAutomataStates.s5);
                this.setState(this.transiteToStable(AutomobileAutomataStates.s5));
                break;
            }
            if (((sourceState == AutomobileAutomataStates.s4) && (this.a.x4() && this.a.x5() && (this.a.x3() == 1))) && (true)) {
                this.exitStateRange(AutomobileAutomataStates.s4, AutomobileAutomataStates.ROOT);
                this.a.z5();
                this.enterStateRange(AutomobileAutomataStates.ROOT, AutomobileAutomataStates.s6);
                this.setState(this.transiteToStable(AutomobileAutomataStates.s6));
                break;
            }
            if (((sourceState == AutomobileAutomataStates.s4) && (this.a.x4() && this.a.x5() && (this.a.x3() == 0))) && (true)) {
                this.exitStateRange(AutomobileAutomataStates.s4, AutomobileAutomataStates.ROOT);
                this.a.z5();
                this.enterStateRange(AutomobileAutomataStates.ROOT, AutomobileAutomataStates.s7);
                this.setState(this.transiteToStable(AutomobileAutomataStates.s7));
                break;
            }
            if (((sourceState == AutomobileAutomataStates.s5) && (this.a.x6())) && (true)) {
                this.exitStateRange(AutomobileAutomataStates.s5, AutomobileAutomataStates.ROOT);
                this.a.z6();
                this.enterStateRange(AutomobileAutomataStates.ROOT, AutomobileAutomataStates.s0);
                this.setState(this.transiteToStable(AutomobileAutomataStates.s0));
                break;
            }
            if (((sourceState == AutomobileAutomataStates.s6) && (this.a.x6())) && (true)) {
                this.exitStateRange(AutomobileAutomataStates.s6, AutomobileAutomataStates.ROOT);
                this.a.z6();
                this.enterStateRange(AutomobileAutomataStates.ROOT, AutomobileAutomataStates.s0);
                this.setState(this.transiteToStable(AutomobileAutomataStates.s0));
                break;
            }
            if (((sourceState == AutomobileAutomataStates.s7) && (this.a.x6())) && (true)) {
                this.exitStateRange(AutomobileAutomataStates.s7, AutomobileAutomataStates.ROOT);
                this.a.z6();
                this.enterStateRange(AutomobileAutomataStates.ROOT, AutomobileAutomataStates.s0);
                this.setState(this.transiteToStable(AutomobileAutomataStates.s0));
                break;
            }
            if (((sourceState == AutomobileAutomataStates.s0) && (true)) && (true)) {
                this.a.z1();
                break;
            }
            if (((sourceState == AutomobileAutomataStates.s2) && (true)) && (true)) {
                this.a.z0();
                this.a.z1();
                break;
            }
            if (((sourceState == AutomobileAutomataStates.s3) && (true)) && (true)) {
                this.a.z0();
                break;
            }
            if (((sourceState == AutomobileAutomataStates.s4) && (true)) && (true)) {
                this.a.z0();
                break;
            }
            if (((sourceState == AutomobileAutomataStates.s5) && (true)) && (true)) {
                this.a.z0();
                this.a.z2();
                break;
            }
            if (((sourceState == AutomobileAutomataStates.s6) && (true)) && (true)) {
                this.a.z0();
                this.a.z2();
                break;
            }
            if (((sourceState == AutomobileAutomataStates.s7) && (true)) && (true)) {
                this.a.z0();
                this.a.z2();
                break;
            }
        }
        return;
    }
}
